<div>

  <h1>Live combination</h1>

  <br>

  <form (change)="configComparationForm.markAsDirty()" nz-form [nzLayout]="'inline'" [formGroup]="configComparationForm" (ngSubmit)="submitForm()">
    <nz-form-item>
      <nz-form-control nzErrorTip="Please input base asset!">
        <nz-input-group nzPrefixIcon="trademark">
          <input style="max-width: 4rem" formControlName="baseAsset" nz-input type="text" placeholder="BTC" />
        </nz-input-group>
      </nz-form-control>
    </nz-form-item>

    <nz-form-item>
      <nz-form-control nzErrorTip="Please input quote asset!">
        <nz-input-group nzPrefixIcon="trademark">
          <input style="max-width: 4rem" formControlName="quoteAsset" nz-input type="text" placeholder="USD" />
        </nz-input-group>
      </nz-form-control>
    </nz-form-item>


    <nz-form-item>
      <nz-form-control nzErrorTip="Please input base asset USD value">
        <nz-input-group nzAddOnAfter="$" nzPrefixIcon="swap">
          <input style="max-width: 8rem" formControlName="baseUsd" nz-input type="number" placeholder="25000" />
        </nz-input-group>
      </nz-form-control>
    </nz-form-item>

    <nz-form-item>
      <nz-form-control nzErrorTip="Please input minimum required rentability efficiency ( in percent ) !">
        <nz-input-group nzAddOnAfter="%" nzPrefixIcon="line-chart">
          <input style="max-width: 3rem" formControlName="minimumEfficiency" nz-input step="0.1" type="number" placeholder="3.1" />
        </nz-input-group>
      </nz-form-control>
    </nz-form-item>


    <nz-form-item style="display: none">
      <nz-form-control nzErrorTip="Please input the total amount of usd you want to spend !">
        <nz-input-group nzAddOnAfter="$" nzPrefixIcon="dollar-circle" >
          <input style="max-width: 4rem" formControlName="usdToSpend" nz-input type="number" placeholder="200" />
        </nz-input-group>
      </nz-form-control>
    </nz-form-item>




    <nz-form-item>
      <nz-form-control>
        <button nz-button nzType="primary" [disabled]="comparationState.launching || !configComparationForm.dirty">Update</button>
      </nz-form-control>
    </nz-form-item>

  </form>

  <br>

  <h3 [ngStyle]="{ margin: '16px 0' }"> Metadata </h3>

<section>
  <div style="display: flex; justify-content: left">
    <nz-list  nzBordered nzSize="small">
      <nz-list-header>Selected markets</nz-list-header>
      <div style="max-height: 15rem; overflow-y: scroll; ">
        <nz-list-item *ngFor="let exchange of exchangesMetadata.exchanges">{{exchange}}</nz-list-item>
      </div>
    </nz-list>

    <nz-list  nzBordered nzSize="small">
      <nz-list-header>Market combinations</nz-list-header>
      <div style="max-height: 15rem; overflow-y: scroll; ">
        <nz-list-item *ngFor="let combination of exchangesMetadata.exchangeCompatibilities">{{combination}}</nz-list-item>
      </div>
    </nz-list>
  </div>
</section>


  <br>

  <section>
    <button *ngIf="!comparationState.started" [nzLoading]="comparationState.launching" (click)="startComparation()" nz-button nzType="primary" > {{comparationState.launching ? 'STARTING' : 'START' }}</button>
    <button  *ngIf="comparationState.started" (click)="stopComparation()" nz-button nzType="danger"> STOP </button>
  </section>

  <br>
  <br>

  <section style="height: 30rem">
    <h3 style="color: #0093ff">ENCORE RENTABLE</h3>
    <nz-table
      #basicTable
      [nzWidthConfig]="['7%','15%','11%','16%','10%','8.5%','8.5%']"
      nzBordered
      [nzData]="profitableCombinations"
      [nzFrontPagination]="false"
    >
      <thead>
      <tr>
        <th rowspan="5">PAIRE</th>
        <th colspan ="2" style="background-color: rgba(144,255,99,0.76)" >ACHAT</th>
        <th colspan ="2" style="background-color: rgba(255,104,104,0.84)">VENTE</th>
        <th colspan="2">RENTABILITE</th>
        <th rowspan="5"> Last update </th>
      </tr>

      <tr>
        <th style="background-color:  rgba(144,255,99,0.76)">Price </th>
        <th style="background-color:  rgba(144,255,99,0.76)">Market</th>
        <th style="background-color: rgba(255,104,104,0.84)">Market</th>
        <th style="background-color: rgba(255,104,104,0.84)">Price </th>
        <th > Marge </th>
        <th > Rentable depuis </th>
      </tr>

      </thead>

      <tbody>

      <tr *ngFor="let combination of basicTable.data">
        <td>{{combination.pair}}</td>
        <td style="background-color: rgba(225,255,213,0.69)" > {{combination.buy.price | exponentiel : 6}} {{combination.quote}}</td>
        <td style="background-color: rgba(224,255,210,0.69)" >  <nz-tag > {{combination.buy.market}} </nz-tag> </td>
        <td style="background-color: rgba(255,200,200,0.3)" >  <nz-tag > {{combination.sell.market}} </nz-tag> </td>
        <td style="background-color: rgba(255,200,200,0.3)" >{{combination.sell.price | exponentiel : 6}} {{combination.quote}}</td>
        <td>  <nz-tag nzColor="#377838">{{combination.efficiency}} % </nz-tag> </td>

        <td> <nz-tag nzColor="blue"> {{timers.get(combination.name)}} s </nz-tag> </td>
        <td>{{combination.timestamp | date: 'HH:mm'}}</td>
      </tr>
      </tbody>
    </nz-table>
  </section>
  <br>
  <hr>
  <br>
  <section>

    <h3 style="color: #c78f00">HISTORIQUE DES RENTABILITES </h3>
    <button (click)="clearHistoric()" nz-button nzType="default" > CLEAR</button>

    <br>
    <br>


    <nz-table
      #otherTable
      [nzWidthConfig]="['7%','15%','11%','16%','10%']"
      nzBordered
      [nzData]="previousProfitableCombinations"
      [nzFrontPagination]="false"
    >
      <thead>
      <tr>
        <th rowspan="5">PAIRE</th>
        <th rowspan="5" style="background-color: rgba(144,255,99,0.76)" >ACHAT</th>
        <th rowspan="5" style="background-color: rgba(255,104,104,0.84)">VENTE</th>
        <th rowspan="5"> Rentabilité cible</th>
        <th rowspan="5"> Durée de rentabilité </th>
      </tr>

      </thead>

      <tbody>

      <tr *ngFor="let combinationSummary of otherTable.data">
        <td>{{combinationSummary.pair}}</td>
        <td style="background-color: rgba(224,255,210,0.69)" >  <nz-tag > {{combinationSummary.buy.market}} </nz-tag> </td>
        <td style="background-color: rgba(255,200,200,0.3)" >  <nz-tag > {{combinationSummary.sell.market}} </nz-tag> </td>
        <td>  <nz-tag nzColor="green">{{combinationSummary.targetEfficiency}} % </nz-tag> </td>
        <td> <nz-tag nzColor="blue"> {{combinationSummary.rentabilityDuration}} s </nz-tag> </td>
      </tr>
      </tbody>
    </nz-table>
  </section>

</div>
